REM Router Rebooter
REM By Robert Chadwick
REM 05-01-17
REM
REM This should be run every 5 minutes or so as a task
REM This will check if the Internet is down for more than 12 minutes.
REM If it is, it will reboot the router, write to a log, and exit
REM If not, it will exit

@echo off

@SET Counter=0

:START

SET /A COUNTER=COUNTER+1
REM First Pass
ping -n 4 google.com -w 20000 >nul


if %errorlevel% == 0 (
  GOTO ENDOFSCRIPT
)

Timeout /t 22
@set errorlevel = 0

REM Below just for testing
 ECHO The counter is %COUNTER%


if %COUNTER% == 10 (
  REM Failed the First Internet Check google.com, going to the next check
  SET Counter=0
  echo Internet offline 4 minutes>> log.txt
  Time /t >> log.txt
  Date /t >> log.txt
  GOTO SECONDTRY
)


GOTO START

:SECONDTRY

ECHO WE ARE AT SECONDTRY
SET /A COUNTER=COUNTER+1
REM First Pass
ping -n 4 yahoo.com -w 20000 >nul


if %errorlevel% == 0 (
  GOTO ENDOFSCRIPT
)

Timeout /t 22
@set errorlevel = 0

REM Below just for testing
 ECHO The counter is %COUNTER%


if %COUNTER% == 10 (
  REM Failed the First Internet Check google.com, going to the next check
  SET Counter=0
  echo Internet offline 8 minutes>> log.txt
  Time /t >> log.txt
  Date /t >> log.txt
  GOTO THIRDTRY
)


GOTO SECONDTRY

:THIRDTRY

ECHO WE ARE AT THIRDTRY

SET /A COUNTER=COUNTER+1
REM First Pass
ping -n 4 comcast.net -w 20000 >nul


if %errorlevel% == 0 (
  GOTO ENDOFSCRIPT
)

Timeout /t 22
@set errorlevel = 0

REM Below just for testing
 ECHO The counter is %COUNTER%


if %COUNTER% == 10 (
  REM Failed the First Internet Check google.com, going to the next check
  GOTO FINALOFFLINE
)

GOTO THIRDTRY

:FINALOFFLINE

ECHO INTERNET OFFLINE!!!!

  echo ---------------- >> log.txt
  echo Internet offline 12 minutes >> log.txt
  Time /t >> log.txt
  Date /t >> log.txt
  echo Rebooting Router >> log.txt
  echo ---------------- >> log.txt
  echo - >> log.txt

ECHO HERE WE RUN SCRIPT TO REBOOT ROUTER

REM THE FIRST TIME this is run, need to cache key. Just run it, select Yes.
plink.exe -ssh <<IP ADDRESS OF YOUR ROUTER>> -l loginuser -pw <<YOUR PASSWORD HERE>> -m rebootsophos.txt 

REM Now we wait 2 minutes 10 seconds for the router to reboot
Timeout /t 130

:ENDOFSCRIPT
REM Here is the end

